import { delegateEvents as be, getNextElement as m, getNextMarker as x, insert as h, createComponent as c, effect as ne, setAttribute as he, runHydrationEvents as se, template as k, spread as Qe, hydrate as Ye, render as Ze } from "solid-js/web";
import { createSignal as z, onMount as ve, onCleanup as Ge, For as Je, Show as v, createEffect as et, createContext as tt, useContext as nt } from "solid-js";
import { Compartment as ye, SelectionRange as ot, EditorSelection as rt, RangeSetBuilder as $e, Transaction as it, EditorState as at } from "@codemirror/state";
import { EditorView as I, Decoration as L, ViewPlugin as we, keymap as lt } from "@codemirror/view";
import { syntaxTree as ce, syntaxHighlighting as st, HighlightStyle as ct } from "@codemirror/language";
import { defaultKeymap as dt, historyKeymap as ut, indentMore as ft, indentLess as gt, history as pt } from "@codemirror/commands";
import { markdown as mt, markdownLanguage as kt } from "@codemirror/lang-markdown";
import { languages as ht } from "@codemirror/language-data";
import { tags as d } from "@lezer/highlight";
const xt = "data-ink-mde-ssr-hydration-marker", bt = `[${xt}]`, vt = () => ({}), H = {
  array: "[object Array]",
  object: "[object Object]",
  string: "[object String]",
  undefined: "[object Undefined]",
  window: "[object Window]"
}, yt = (e) => {
  if (Object.prototype.toString.call(e) === H.object)
    return `[object ${e.constructor.name}]`;
}, j = (e, t) => yt(e) === t, $t = (e, t) => {
  const n = /* @__PURE__ */ new WeakMap(), o = (r, i) => n.get(r) || (j(r, H.object) && n.set(r, !0), j(i, H.undefined)) ? r : j(r, H.array) && j(i, H.array) ? [...i] : j(r, H.object) && j(i, H.object) ? Object.keys(r).reduce((l, a) => (Object.hasOwnProperty.call(i, a) ? l[a] = o(r[a], i[a]) : l[a] = r[a], l), {}) : i;
  return o(e, t);
}, R = (e, t) => $t(e, t);
var V = /* @__PURE__ */ ((e) => (e.Auto = "auto", e.Dark = "dark", e.Light = "light", e))(V || {}), wt = /* @__PURE__ */ ((e) => (e.Appearance = "appearance", e.Attribution = "attribution", e.Autocomplete = "autocomplete", e.Images = "images", e.ReadOnly = "readonly", e.Spellcheck = "spellcheck", e.Vim = "vim", e))(wt || {}), g = /* @__PURE__ */ ((e) => (e.Bold = "bold", e.Code = "code", e.CodeBlock = "code_block", e.Heading = "heading", e.Image = "image", e.Italic = "italic", e.Link = "link", e.List = "list", e.OrderedList = "ordered_list", e.Quote = "quote", e.TaskList = "task_list", e))(g || {}), oe = /* @__PURE__ */ ((e) => (e.Completion = "completion", e.Default = "default", e.Grammar = "grammar", e))(oe || {}), re = /* @__PURE__ */ ((e) => (e.End = "end", e.Start = "start", e))(re || {});
const xe = () => document.createElement("div"), _e = () => window.matchMedia("(prefers-color-scheme: dark)").matches, _t = (e) => e === V.Dark ? !0 : e === V.Light ? !1 : _e(), te = (e) => {
  const t = [
    { suffix: "border-radius", default: "0.25rem" },
    { suffix: "color", default: "currentColor" },
    { suffix: "flex-direction", default: "column" },
    { suffix: "font-family", default: "inherit" },
    { suffix: "block-background-color", default: "#121212", light: "#f5f5f5" },
    { suffix: "block-background-color-on-hover", default: "#0f0f0f", light: "#e0e0e0" },
    { suffix: "block-max-height", default: "20rem" },
    { suffix: "block-padding", default: "0.5rem" },
    { suffix: "code-background-color", default: "var(--ink-internal-block-background-color)" },
    { suffix: "code-color", default: "inherit" },
    { suffix: "code-font-family", default: "'Monaco', Courier, monospace" },
    { suffix: "editor-font-size", default: "1em" },
    { suffix: "editor-line-height", default: "2em" },
    { suffix: "editor-padding", default: "0.5rem" },
    { suffix: "inline-padding", default: "0.125rem" },
    { suffix: "modal-position", default: "fixed" },
    { suffix: "syntax-atom-color", default: "#d19a66" },
    { suffix: "syntax-comment-color", default: "#abb2bf" },
    { suffix: "syntax-comment-font-style", default: "italic" },
    { suffix: "syntax-emphasis-color", default: "inherit" },
    { suffix: "syntax-emphasis-font-style", default: "italic" },
    { suffix: "syntax-hashtag-background-color", default: "#222", light: "#eee" },
    { suffix: "syntax-hashtag-color", default: "inherit" },
    { suffix: "syntax-heading-color", default: "inherit" },
    { suffix: "syntax-heading-font-weight", default: "600" },
    { suffix: "syntax-heading1-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading1-font-size", default: "1.6em" },
    { suffix: "syntax-heading1-font-weight", default: "600" },
    { suffix: "syntax-heading2-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading2-font-size", default: "1.5em" },
    { suffix: "syntax-heading2-font-weight", default: "600" },
    { suffix: "syntax-heading3-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading3-font-size", default: "1.4em" },
    { suffix: "syntax-heading3-font-weight", default: "600" },
    { suffix: "syntax-heading4-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading4-font-size", default: "1.3em" },
    { suffix: "syntax-heading4-font-weight", default: "600" },
    { suffix: "syntax-heading5-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading5-font-size", default: "1.2em" },
    { suffix: "syntax-heading5-font-weight", default: "600" },
    { suffix: "syntax-heading6-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading6-font-size", default: "1.1em" },
    { suffix: "syntax-heading6-font-weight", default: "600" },
    { suffix: "syntax-highlight-background-color", default: "#555555" },
    { suffix: "syntax-keyword-color", default: "#c678dd" },
    { suffix: "syntax-link-color", default: "inherit" },
    { suffix: "syntax-meta-color", default: "#abb2bf" },
    { suffix: "syntax-monospace-color", default: "var(--ink-internal-code-color)" },
    { suffix: "syntax-monospace-font-family", default: "var(--ink-internal-code-font-family)" },
    { suffix: "syntax-name-color", default: "#d19a66" },
    { suffix: "syntax-name-label-color", default: "#abb2bf" },
    { suffix: "syntax-name-property-color", default: "#96c0d8" },
    { suffix: "syntax-name-property-definition-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-definition-color", default: "#e5c07b" },
    { suffix: "syntax-name-variable-local-color", default: "#d19a66" },
    { suffix: "syntax-name-variable-special-color", default: "inherit" },
    { suffix: "syntax-number-color", default: "#d19a66" },
    { suffix: "syntax-operator-color", default: "#96c0d8" },
    { suffix: "syntax-processing-instruction-color", default: "#444444", light: "#bbbbbb" },
    { suffix: "syntax-punctuation-color", default: "#abb2bf" },
    { suffix: "syntax-strikethrough-color", default: "inherit" },
    { suffix: "syntax-strikethrough-text-decoration", default: "line-through" },
    { suffix: "syntax-string-color", default: "#98c379" },
    { suffix: "syntax-string-special-color", default: "inherit" },
    { suffix: "syntax-strong-color", default: "inherit" },
    { suffix: "syntax-strong-font-weight", default: "600" },
    { suffix: "syntax-url-color", default: "#aaaaaa", light: "#666666" }
  ], n = !_t(e.options.interface.appearance);
  return t.map((o) => {
    const r = n && o.light ? o.light : o.default;
    return `--ink-internal-${o.suffix}: var(--ink-${o.suffix}, ${r});`;
  });
}, Ct = (e) => [
  I.theme({}, { dark: e })
], Lt = (e) => e.extensions.map((t) => t.initialValue(e)), de = (e) => Promise.all(
  e.extensions.map((t) => t.reconfigure(e.options))
), St = (e) => {
  const t = new ye();
  return {
    compartment: t,
    initialValue: (n) => t.of(e(n.options)),
    reconfigure: (n) => t.reconfigure(e(n))
  };
}, Mt = (e) => {
  const t = new ye();
  return {
    compartment: t,
    initialValue: (n) => t.of([]),
    reconfigure: (n) => e(n, t)
  };
}, Dt = () => [
  ...At.map((e) => St(e)),
  ...Ht.map((e) => Mt(e))
], At = [
  (e) => {
    const t = e.interface.appearance === V.Dark, n = e.interface.appearance === V.Auto;
    return Ct(t || n && _e());
  }
], Ht = [
  async (e, t) => {
    if (e.interface.autocomplete) {
      const { autocomplete: n } = await import("./autocomplete.b61ec17b.js");
      return t.reconfigure(n(e));
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.images) {
      const { images: n } = await import("./images.0bde9a43.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.lists) {
      const { lists: n } = await import("./lists.f0515d6b.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.readonly) {
      const { readonly: n } = await import("./readonly.90b28a57.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.spellcheck) {
      const { spellcheck: n } = await import("./spellcheck.7e0765c7.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.vim) {
      const { vim: n } = await import("./vim.e0ec79d3.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  }
], ie = () => {
  const e = {
    doc: "",
    files: {
      clipboard: !1,
      dragAndDrop: !1,
      handler: () => {
      },
      injectMarkup: !0,
      types: ["image/*"]
    },
    hooks: {
      afterUpdate: () => {
      },
      beforeUpdate: () => {
      }
    },
    interface: {
      appearance: V.Auto,
      attribution: !0,
      autocomplete: !1,
      images: !1,
      lists: !1,
      readonly: !1,
      spellcheck: !0,
      toolbar: !1
    },
    plugins: [],
    selections: [],
    toolbar: {
      bold: !0,
      code: !0,
      codeBlock: !0,
      heading: !0,
      image: !0,
      italic: !0,
      link: !0,
      list: !0,
      orderedList: !0,
      quote: !0,
      taskList: !0,
      upload: !1
    },
    vim: !1
  };
  return {
    editor: {},
    extensions: Dt(),
    options: e,
    root: xe(),
    target: xe()
  };
}, zt = (e) => R(ie(), e), ue = (e, t = {}) => {
  const [n, o] = z(zt({ ...t, options: e }));
  return [n, o];
}, Bt = ([e]) => {
  const { editor: t } = e();
  t.destroy();
}, ae = ([e]) => {
  const { editor: t } = e();
  t.hasFocus || t.focus();
}, _ = (e) => ({ ...{
  block: !1,
  line: !1,
  multiline: !1,
  nodes: [],
  prefix: "",
  prefixStates: [],
  suffix: ""
}, ...e }), Et = {
  [g.Bold]: _({
    nodes: ["StrongEmphasis"],
    prefix: "**",
    suffix: "**"
  }),
  [g.Code]: _({
    nodes: ["InlineCode"],
    prefix: "`",
    suffix: "`"
  }),
  [g.CodeBlock]: _({
    block: !0,
    nodes: ["FencedCode"],
    prefix: "```\n",
    suffix: "\n```"
  }),
  [g.Heading]: _({
    multiline: !0,
    nodes: ["ATXHeading1", "ATXHeading2", "ATXHeading3", "ATXHeading4", "ATXHeading5", "ATXHeading6"],
    prefix: "# ",
    prefixStates: ["# ", "## ", "### ", "#### ", "##### ", "###### ", ""]
  }),
  [g.Image]: _({
    nodes: ["Image"],
    prefix: "![](",
    suffix: ")"
  }),
  [g.Italic]: _({
    nodes: ["Emphasis"],
    prefix: "*",
    suffix: "*"
  }),
  [g.Link]: _({
    nodes: ["Link"],
    prefix: "[](",
    suffix: ")"
  }),
  [g.OrderedList]: _({
    line: !0,
    multiline: !0,
    nodes: ["OrderedList"],
    prefix: "1. "
  }),
  [g.Quote]: _({
    line: !0,
    multiline: !0,
    nodes: ["Blockquote"],
    prefix: "> "
  }),
  [g.TaskList]: _({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- [ ] "
  }),
  [g.List]: _({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- "
  })
}, Ce = ([e, t], n) => {
  const { editor: o } = e(), r = o.lineBlockAt(n.start), i = o.lineBlockAt(n.end);
  return { start: r.from, end: i.to };
}, jt = ([e, t], n) => {
  const { editor: o } = e();
  let r = n.start;
  const i = [];
  for (; r <= n.end; ) {
    const l = o.lineBlockAt(r), a = Math.max(r, l.from), s = Math.min(r, l.to);
    i.push({ start: a, end: s }), r = l.to + 1;
  }
  return i;
}, Vt = ([e, t], n) => {
  const { editor: o } = e(), r = o.state.wordAt(n.start)?.from || n.start, i = o.state.wordAt(n.end)?.to || n.end;
  return { start: r, end: i };
}, Ot = ([e, t], n) => n || Y([e, t]).pop() || { start: 0, end: 0 }, Le = ([e, t], n) => {
  const { editor: o } = e();
  return o.state.sliceDoc(n.start, n.end);
}, fe = ([e, t], n, o) => Nt(e(), o).find(({ type: i }) => n.nodes.includes(i.name)), Nt = ({ editor: { state: e } }, t) => {
  const n = [];
  return ce(e).iterate({
    from: t.start,
    to: t.end,
    enter: ({ type: o, from: r, to: i }) => {
      n.push({ type: o, from: r, to: i });
    }
  }), n;
}, ge = ([e, t], n, o) => {
  const r = Le([e, t], o), i = n.prefix.length, l = n.suffix.length * -1 || r.length, a = r.slice(i, l);
  O([e, t], a, o);
}, Tt = ([e, t], n, o) => {
  const r = Ce([e, t], o), i = fe([e, t], n, r);
  if (i) {
    const l = i.from, a = i.to;
    ge([e, t], n, { start: l, end: a });
  } else {
    const l = n.prefix, a = n.suffix;
    Z([e, t], { before: l, after: a, selection: r });
  }
}, qt = ([e, t], n, o) => {
  jt([e, t], o).forEach((i) => {
    Se([e, t], n, i);
  });
}, Se = ([e, t], n, o) => {
  const r = Ce([e, t], o), i = fe([e, t], n, r), l = n.prefixStates.length > 0;
  if (i && l)
    n.prefixStates.find((a, s) => {
      const u = i.from, b = i.to, y = Le([e, t], { start: u, end: b }), C = y.startsWith(a);
      return C && O([e, t], y.replace(new RegExp(`^${a}`), n.prefixStates[s + 1]), { start: u, end: b }), C;
    });
  else if (i) {
    const a = i.from, s = i.to;
    ge([e, t], n, { start: a, end: s });
  } else {
    const a = n.prefix, s = n.suffix;
    Z([e, t], { before: a, after: s, selection: r });
  }
}, It = ([e, t], n, o) => {
  const r = fe([e, t], n, o);
  if (r) {
    const i = r.from, l = r.to;
    ge([e, t], n, { start: i, end: l });
  } else {
    const { start: i, end: l } = Vt([e, t], o), a = Array.isArray(n.prefix) ? n.prefix[0] : n.prefix, s = n.suffix;
    Z([e, t], { before: a, after: s, selection: { start: i, end: l } });
  }
}, Me = ([e, t], n, { selection: o } = {}) => {
  const r = Et[n], i = Ot([e, t], o);
  r.block ? Tt([e, t], r, i) : r.multiline ? qt([e, t], r, i) : r.line ? Se([e, t], r, i) : It([e, t], r, i);
}, Rt = ([e]) => {
  const { editor: t } = e();
  return t.state.sliceDoc();
}, De = (e) => {
  const t = e.map((n) => ot.fromJSON({ anchor: n.start, head: n.end }));
  return rt.create(t);
}, Pt = (e) => e.ranges.map((n) => ({
  end: n.anchor < n.head ? n.head : n.anchor,
  start: n.head < n.anchor ? n.head : n.anchor
})), Y = ([e]) => {
  const { editor: t } = e();
  return Pt(t.state.selection);
}, O = ([e, t], n, o, r = !1) => {
  const { editor: i } = e();
  let l = o?.start, a = o?.end || o?.start;
  if (typeof l > "u") {
    const u = Y([e, t]).pop();
    l = u.start, a = u.end;
  }
  const s = { changes: { from: l, to: a, insert: n } };
  if (r) {
    const u = l === a ? l + n.length : l, b = l + n.length;
    Object.assign(s, { selection: { anchor: u, head: b } });
  }
  i.dispatch(
    i.state.update(s)
  );
}, Wt = [
  "Blockquote"
], Ft = L.line({ attributes: { class: "cm-blockquote" } }), Ut = L.line({ attributes: { class: "cm-blockquote-open" } }), Xt = L.line({ attributes: { class: "cm-blockquote-close" } }), Kt = we.define((e) => ({
  update: () => Qt(e)
}), { decorations: (e) => e.update() }), Qt = (e) => {
  const t = new $e(), n = ce(e.state);
  for (const o of e.visibleRanges)
    for (let r = o.from; r < o.to; ) {
      const i = e.state.doc.lineAt(r);
      n.iterate({
        enter({ type: l, from: a, to: s }) {
          if (l.name !== "Document" && Wt.includes(l.name)) {
            t.add(i.from, i.from, Ft);
            const u = e.state.doc.lineAt(a), b = e.state.doc.lineAt(s);
            return u.number === i.number && t.add(i.from, i.from, Ut), b.number === i.number && t.add(i.from, i.from, Xt), !1;
          }
        },
        from: i.from,
        to: i.to
      }), r = i.to + 1;
    }
  return t.finish();
}, Yt = () => [
  Kt
], Zt = [
  "CodeBlock",
  "FencedCode",
  "HTMLBlock",
  "CommentBlock"
], Gt = L.line({ attributes: { class: "cm-codeblock" } }), Jt = L.line({ attributes: { class: "cm-codeblock-open" } }), en = L.line({ attributes: { class: "cm-codeblock-close" } }), tn = L.mark({ attributes: { class: "cm-code" } }), nn = L.mark({ attributes: { class: "cm-code cm-code-open" } }), on = L.mark({ attributes: { class: "cm-code cm-code-close" } }), rn = we.define((e) => ({
  update: () => an(e)
}), { decorations: (e) => e.update() }), an = (e) => {
  const t = new $e(), n = ce(e.state);
  for (const o of e.visibleRanges)
    for (let r = o.from; r < o.to; ) {
      const i = e.state.doc.lineAt(r);
      let l;
      n.iterate({
        enter({ type: a, from: s, to: u }) {
          if (a.name !== "Document")
            if (Zt.includes(a.name)) {
              t.add(i.from, i.from, Gt);
              const b = e.state.doc.lineAt(s), y = e.state.doc.lineAt(u);
              return b.number === i.number && t.add(i.from, i.from, Jt), y.number === i.number && t.add(i.from, i.from, en), !1;
            } else
              a.name === "InlineCode" ? l = { from: s, to: u, innerFrom: s, innerTo: u } : a.name === "CodeMark" && (s === l.from ? (l.innerFrom = u, t.add(s, u, nn)) : u === l.to && (l.innerTo = s, t.add(l.innerFrom, l.innerTo, tn), t.add(s, u, on)));
        },
        from: i.from,
        to: i.to
      }), r = i.to + 1;
    }
  return t.finish();
}, ln = () => [
  rn
], sn = () => [
  I.editorAttributes.of({
    class: "ink-mde-editor"
  }),
  I.contentAttributes.of({
    class: "ink-mde-editor-content"
  })
], cn = () => [
  ...sn()
], dn = [
  {
    key: "Tab",
    run: ({ state: e, dispatch: t }) => e.selection.ranges.some((n) => !n.empty) ? ft({ state: e, dispatch: t }) : (t(
      e.update(e.replaceSelection("  "), {
        scrollIntoView: !0,
        annotations: it.userEvent.of("input")
      })
    ), !0),
    shift: gt
  }
], un = () => lt.of([
  ...dn,
  ...dt,
  ...ut
]), fn = () => I.lineWrapping, gn = () => [
  st(
    ct.define([
      {
        tag: d.atom,
        color: "var(--ink-internal-syntax-atom-color)"
      },
      {
        tag: d.meta,
        color: "var(--ink-internal-syntax-meta-color)"
      },
      {
        tag: d.emphasis,
        color: "var(--ink-internal-syntax-emphasis-color)",
        fontStyle: "var(--ink-internal-syntax-emphasis-font-style)"
      },
      {
        tag: d.strong,
        color: "var(--ink-internal-syntax-strong-color)",
        fontWeight: "var(--ink-internal-syntax-strong-font-weight)"
      },
      {
        tag: d.strikethrough,
        color: "var(--ink-internal-syntax-strikethrough-color)",
        textDecoration: "var(--ink-internal-syntax-strikethrough-text-decoration)"
      },
      {
        tag: d.comment,
        color: "var(--ink-internal-syntax-comment-color)",
        fontStyle: "var(--ink-internal-syntax-comment-font-style)"
      },
      {
        tag: d.monospace,
        color: "var(--ink-internal-syntax-code-color)",
        fontFamily: "var(--ink-internal-syntax-code-font-family)"
      },
      {
        tag: d.name,
        color: "var(--ink-internal-syntax-name-color)"
      },
      {
        tag: d.labelName,
        color: "var(--ink-internal-syntax-name-label-color)"
      },
      {
        tag: d.propertyName,
        color: "var(--ink-internal-syntax-name-property-color)"
      },
      {
        tag: d.definition(d.propertyName),
        color: "var(--ink-internal-syntax-name-property-definition-color)"
      },
      {
        tag: d.variableName,
        color: "var(--ink-internal-syntax-name-variable-color)"
      },
      {
        tag: d.definition(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-definition-color)"
      },
      {
        tag: d.local(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-local-color)"
      },
      {
        tag: d.special(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-special-color)"
      },
      {
        tag: d.heading,
        color: "var(--ink-internal-syntax-heading-color)",
        fontWeight: "var(--ink-internal-syntax-heading-font-weight)"
      },
      {
        tag: d.heading1,
        color: "var(--ink-internal-syntax-heading1-color)",
        fontSize: "var(--ink-internal-syntax-heading1-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading1-font-weight)"
      },
      {
        tag: d.heading2,
        color: "var(--ink-internal-syntax-heading2-color)",
        fontSize: "var(--ink-internal-syntax-heading2-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading2-font-weight)"
      },
      {
        tag: d.heading3,
        color: "var(--ink-internal-syntax-heading3-color)",
        fontSize: "var(--ink-internal-syntax-heading3-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading3-font-weight)"
      },
      {
        tag: d.heading4,
        color: "var(--ink-internal-syntax-heading4-color)",
        fontSize: "var(--ink-internal-syntax-heading4-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading4-font-weight)"
      },
      {
        tag: d.heading5,
        color: "var(--ink-internal-syntax-heading5-color)",
        fontSize: "var(--ink-internal-syntax-heading5-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading5-font-weight)"
      },
      {
        tag: d.heading6,
        color: "var(--ink-internal-syntax-heading6-color)",
        fontSize: "var(--ink-internal-syntax-heading6-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading6-font-weight)"
      },
      {
        tag: d.keyword,
        color: "var(--ink-internal-syntax-keyword-color)"
      },
      {
        tag: d.number,
        color: "var(--ink-internal-syntax-number-color)"
      },
      {
        tag: d.operator,
        color: "var(--ink-internal-syntax-operator-color)"
      },
      {
        tag: d.punctuation,
        color: "var(--ink-internal-syntax-punctuation-color)"
      },
      {
        tag: d.link,
        color: "var(--ink-internal-syntax-link-color)"
      },
      {
        tag: d.url,
        color: "var(--ink-internal-syntax-url-color)"
      },
      {
        tag: d.string,
        color: "var(--ink-internal-syntax-string-color)"
      },
      {
        tag: d.special(d.string),
        color: "var(--ink-internal-syntax-string-special-color)"
      },
      {
        tag: d.processingInstruction,
        color: "var(--ink-internal-syntax-processing-instruction-color)"
      }
    ])
  )
], pn = (e) => {
  if (e.length > 0)
    return De(e);
}, Ae = (e) => {
  const t = e.options.plugins.flatMap((o) => o.type === oe.Default ? o.value : []), n = e.options.plugins.flatMap((o) => o.type === oe.Grammar ? o.value : []);
  return at.create({
    doc: e.options.doc,
    selection: pn(e.options.selections),
    extensions: [
      ...Lt(e),
      Yt(),
      ln(),
      pt(),
      cn(),
      un(),
      fn(),
      mt({
        base: kt,
        codeLanguages: ht,
        extensions: n
      }),
      gn(),
      ...t
    ]
  });
}, mn = ([e, t], n) => {
  t(R(e(), { options: { doc: n } })), e().editor.setState(Ae(e()));
}, kn = ([e]) => e().options, hn = async ([e, t], n) => {
  const o = t(R(e(), { options: n })), r = await de(o);
  o.editor.dispatch({ effects: r });
}, He = (e, t = {}) => {
  if (t.selections)
    return ze(e, t.selections);
  if (t.selection)
    return le(e, t.selection);
  if (t.at)
    return xn(e, t.at);
}, xn = (e, t) => {
  const [n] = e;
  if (t === re.Start)
    return le(e, { start: 0, end: 0 });
  if (t === re.End) {
    const o = n().editor.state.doc.length;
    return le(e, { start: o, end: o });
  }
}, ze = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      selection: De(t)
    })
  );
}, le = (e, t) => ze(e, [t]), bn = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      changes: {
        from: 0,
        to: n.state.doc.length,
        insert: t
      }
    })
  );
}, Z = ([e, t], { after: n, before: o, selection: r }) => {
  const { editor: i } = e(), l = r || Y([e, t]).pop() || { start: 0, end: 0 }, a = i.state.sliceDoc(l.start, l.end);
  O([e, t], `${o}${a}${n}`, l), He([e, t], { selections: [{ start: l.start + o.length, end: l.end + o.length }] });
}, Be = (e) => ({
  destroy: Bt.bind(void 0, e),
  focus: ae.bind(void 0, e),
  format: Me.bind(void 0, e),
  getDoc: Rt.bind(void 0, e),
  insert: O.bind(void 0, e),
  load: mn.bind(void 0, e),
  options: kn.bind(void 0, e),
  reconfigure: hn.bind(void 0, e),
  select: He.bind(void 0, e),
  selections: Y.bind(void 0, e),
  update: bn.bind(void 0, e),
  wrap: Z.bind(void 0, e)
}), vn = `.ink-drop-zone{align-items:center;background-color:#00000080;color:var(--ink-internal-color);display:flex;inset:0;justify-content:center;position:var(--ink-internal-modal-position);z-index:100}.ink-drop-zone:not(.visible){display:none}.ink-drop-zone-modal{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);box-sizing:border-box;height:100%;max-height:20rem;max-width:40rem;padding:1rem;position:relative;width:100%}.ink-drop-zone-hide{cursor:pointer;height:1.75rem;position:absolute;right:.25rem;top:.25rem;width:1.75rem}.ink-drop-zone-hide svg{background-color:var(--ink-internal-block-background-color)}.ink-drop-zone-droppable-area{align-items:center;border:.2rem dashed var(--ink-internal-color);border-radius:.125rem;box-sizing:border-box;display:flex;flex-direction:column;font-size:1.25em;gap:1rem;height:100%;justify-content:center;padding:1rem;text-align:center}.ink-drop-zone-file-preview{align-items:center;display:flex;flex-wrap:wrap;gap:.5rem;max-width:25.5rem}.ink-drop-zone-file-preview-image{border:.125rem solid #222;border-radius:.125rem;box-sizing:border-box;height:6rem;object-fit:cover;padding:.5rem;width:6rem}
`, yn = /* @__PURE__ */ k("<span>uploading files...</span>", 2), $n = /* @__PURE__ */ k('<div class="ink-drop-zone"><style></style><div class="ink-drop-zone-modal"><div class="ink-drop-zone-droppable-area"><div class="ink-drop-zone-file-preview"></div><!#><!/></div><div class="ink-drop-zone-hide"><svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg></div></div></div>', 18), wn = /* @__PURE__ */ k('<img class="ink-drop-zone-file-preview-image">', 1), _n = /* @__PURE__ */ k("<span>drop files here</span>", 2), Cn = () => {
  const [e, t] = z(0), [n, o] = z([]), [r, i] = z(!1), [l, a] = z(!1), [s, u] = P(), b = () => {
    a(!1);
  }, y = (f) => {
    if (s().options.files.dragAndDrop) {
      f.preventDefault(), f.stopPropagation();
      const p = f.dataTransfer;
      p?.files ? E(p.files) : (t(0), a(!1), o([]));
    }
  }, C = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), t(e() + 1), a(!0));
  }, S = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), t(e() - 1), e() === 0 && a(!1));
  }, M = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), a(!0));
  }, D = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), t(0), a(!1));
  }, B = (f) => {
    if (s().options.files.clipboard) {
      f.preventDefault();
      const p = f.clipboardData;
      p?.files && p.files.length > 0 && E(p.files);
    }
  }, E = (f) => {
    Array.from(f).forEach((p) => {
      o([...n(), p]);
    }), i(!0), a(!0), Promise.resolve(s().options.files.handler(f)).then((p) => {
      if (s().options.files.injectMarkup && p) {
        const N = `![](${p})`;
        O([s, u], N);
      }
    }).finally(() => {
      t(0), i(!1), a(!1), o([]);
    });
  };
  return ve(() => {
    document.addEventListener("dragenter", C), document.addEventListener("dragleave", S), document.addEventListener("dragover", M), document.addEventListener("drop", D), s().root.addEventListener("paste", B);
  }), Ge(() => {
    document.removeEventListener("dragenter", C), document.removeEventListener("dragleave", S), document.removeEventListener("dragover", M), document.removeEventListener("drop", D), s().root.removeEventListener("paste", B);
  }), (() => {
    const f = m($n), p = f.firstChild, N = p.nextSibling, A = N.firstChild, W = A.firstChild, G = W.nextSibling, [F, J] = x(G.nextSibling), ee = A.nextSibling;
    return p.textContent = vn, A.addEventListener("drop", y), h(W, c(Je, {
      get each() {
        return n().slice(0, 8);
      },
      children: (U) => (() => {
        const T = m(wn);
        return ne((w) => {
          const X = U.name, q = URL.createObjectURL(U);
          return X !== w._v$ && he(T, "alt", w._v$ = X), q !== w._v$2 && he(T, "src", w._v$2 = q), w;
        }, {
          _v$: void 0,
          _v$2: void 0
        }), T;
      })()
    })), h(A, c(v, {
      get when() {
        return r();
      },
      get fallback() {
        return m(_n);
      },
      get children() {
        return m(yn);
      }
    }), F, J), ee.$$click = b, ne(() => f.classList.toggle("visible", !!l())), se(), f;
  })();
};
be(["click"]);
const Ln = (e) => {
  const t = new I({
    dispatch: (n) => {
      const { options: o } = e;
      o.hooks.beforeUpdate(n.newDoc.toString()), t.update([n]), n.docChanged && o.hooks.afterUpdate(n.newDoc.toString());
    },
    state: Ae(e)
  });
  return t;
}, Sn = () => {
  const [e, t] = P(), n = Ln(e());
  return t(R(e(), {
    editor: n
  })), de(e()).then((o) => {
    n.dispatch({
      effects: o
    });
  }), n.dom;
}, Mn = /* @__PURE__ */ k('<button class="ink-button" type="button"></button>', 2), $ = (e) => (() => {
  const t = m(Mn);
  return t.$$click = (n) => e.onclick(n), h(t, () => e.children), se(), t;
})();
be(["click"]);
const Dn = `.ink .ink-toolbar{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);bottom:.25rem;color:inherit;display:flex;flex-shrink:0;gap:2rem;overflow:auto;padding:.25rem;position:sticky;top:.25rem;z-index:10}.ink .ink-toolbar-group{display:flex}.ink .ink-toolbar .ink-button{align-items:center;background:none;border:none;border-radius:var(--ink-internal-border-radius);color:inherit;cursor:pointer;display:flex;height:2.25rem;justify-content:center;padding:.4rem;width:2.25rem}.ink .ink-toolbar .ink-button:hover{background-color:var(--ink-internal-block-background-color-on-hover)}.ink .ink-toolbar .ink-button>*{align-items:center;display:flex;height:100%}
`, An = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6 4V10M6 16V10M6 10H14M14 10V4M14 10V16"></path></svg>', 4), Hn = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-width="1.5" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6.5 10H10.5C12.1569 10 13.5 11.3431 13.5 13C13.5 14.6569 12.1569 16 10.5 16H6.5V4H9.5C11.1569 4 12.5 5.34315 12.5 7C12.5 8.65686 11.1569 10 9.5 10"></path></svg>', 4), zn = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M11 4L9 16M13 4H9M7 16H11"></path></svg>', 4), Bn = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M2.00257 16H17.9955M2.00055 4H18M7 10H18.0659M2 8.5V11.4999C2.4 11.5 2.5 11.5 2.5 11.5V11V10.5M4 8.5V11.4999H4.5V11V10.5"></path></svg>', 4), En = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M13 4L7 16"></path><path d="M5 7L2 10L5 13"></path><path d="M15 7L18 10L15 13"></path></svg>', 8), jn = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 4L8 6"></path></svg>', 4), Vn = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M2 16H4"></path><path d="M7 10H17.8294"></path><path d="M2 10H4"></path><path d="M7 4H17.8294"></path><path d="M2 4H4"></path></svg>', 14), On = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H18"></path><path d="M2 17.0242C2.48314 17.7569 3.94052 17.6154 3.99486 16.7919C4.05315 15.9169 3.1975 16.0044 2.99496 16.0044M2.0023 14.9758C2.48544 14.2431 3.94282 14.3846 3.99716 15.2081C4.05545 16.0831 3.1998 16.0002 2.99726 16.0002"></path><path d="M7 10H18"></path><path d="M2.00501 11.5H4M2.00193 8.97562C2.48449 8.24319 3.9401 8.38467 3.99437 9.20777C4.05259 10.0825 2.04342 10.5788 2 11.4996"></path><path d="M7 4H18"></path><path d="M2 5.5H4M2.99713 5.49952V2.5L2.215 2.93501"></path></svg>', 14), Nn = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M5 15L3 17L2 16"></path><path d="M7 10H17.8294"></path><path d="M5 9L3 11L2 10"></path><path d="M7 4H17.8294"></path><path d="M5 3L3 5L2 4"></path></svg>', 14), Tn = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M9.12127 10.881C10.02 11.78 11.5237 11.7349 12.4771 10.7813L15.2546 8.00302C16.2079 7.04937 16.253 5.54521 15.3542 4.6462C14.4555 3.74719 12.9512 3.79174 11.9979 4.74539L10.3437 6.40007M10.8787 9.11903C9.97997 8.22002 8.47626 8.26509 7.52288 9.21874L4.74545 11.997C3.79208 12.9506 3.74701 14.4548 4.64577 15.3538C5.54452 16.2528 7.04876 16.2083 8.00213 15.2546L9.65633 13.5999"></path></svg>', 4), qn = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><rect x="2" y="4" width="16" height="12" rx="1"></rect><path d="M7.42659 7.67597L13.7751 13.8831M2.00208 12.9778L7.42844 7.67175"></path><path d="M11.9119 12.0599L14.484 9.54443L17.9973 12.9785"></path><path d="M10.9989 7.95832C11.551 7.95832 11.9986 7.52072 11.9986 6.98092C11.9986 6.44113 11.551 6.00354 10.9989 6.00354C10.4468 6.00354 9.99921 6.44113 9.99921 6.98092C9.99921 7.52072 10.4468 7.95832 10.9989 7.95832Z"></path></svg>', 10), In = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M10 13V4M10 4L13 7M10 4L7 7"></path><path d="M2 13V15C2 15.5523 2.44772 16 3 16H17C17.5523 16 18 15.5523 18 15V13"></path></svg>', 6), Rn = /* @__PURE__ */ k('<input type="file">', 1), Pn = /* @__PURE__ */ k('<div class="ink-toolbar"><style></style><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div></div>', 36), Wn = () => {
  const [e, t] = P(), [n, o] = z(), r = (a) => {
    Me([e, t], a), ae([e, t]);
  }, i = (a) => {
    const s = a.target;
    s?.files && Promise.resolve(e().options.files.handler(s.files)).then((u) => {
      const b = `![](${u})`;
      O([e, t], b), ae([e, t]);
    });
  }, l = () => {
    n()?.click();
  };
  return (() => {
    const a = m(Pn), s = a.firstChild, u = s.nextSibling, b = u.firstChild, [y, C] = x(b.nextSibling), S = y.nextSibling, [M, D] = x(S.nextSibling), B = M.nextSibling, [E, f] = x(B.nextSibling), p = u.nextSibling, N = p.firstChild, [A, W] = x(N.nextSibling), G = A.nextSibling, [F, J] = x(G.nextSibling), ee = F.nextSibling, [U, T] = x(ee.nextSibling), w = p.nextSibling, X = w.firstChild, [q, Ve] = x(X.nextSibling), Oe = q.nextSibling, [pe, Ne] = x(Oe.nextSibling), Te = pe.nextSibling, [qe, Ie] = x(Te.nextSibling), K = w.nextSibling, Re = K.firstChild, [me, Pe] = x(Re.nextSibling), We = me.nextSibling, [ke, Fe] = x(We.nextSibling), Ue = ke.nextSibling, [Xe, Ke] = x(Ue.nextSibling);
    return s.textContent = Dn, h(u, c(v, {
      get when() {
        return e().options.toolbar.heading;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Heading),
          get children() {
            return m(An);
          }
        });
      }
    }), y, C), h(u, c(v, {
      get when() {
        return e().options.toolbar.bold;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Bold),
          get children() {
            return m(Hn);
          }
        });
      }
    }), M, D), h(u, c(v, {
      get when() {
        return e().options.toolbar.italic;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Italic),
          get children() {
            return m(zn);
          }
        });
      }
    }), E, f), h(p, c(v, {
      get when() {
        return e().options.toolbar.quote;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Quote),
          get children() {
            return m(Bn);
          }
        });
      }
    }), A, W), h(p, c(v, {
      get when() {
        return e().options.toolbar.codeBlock;
      },
      get children() {
        return c($, {
          onclick: () => r(g.CodeBlock),
          get children() {
            return m(En);
          }
        });
      }
    }), F, J), h(p, c(v, {
      get when() {
        return e().options.toolbar.code;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Code),
          get children() {
            return m(jn);
          }
        });
      }
    }), U, T), h(w, c(v, {
      get when() {
        return e().options.toolbar.list;
      },
      get children() {
        return c($, {
          onclick: () => r(g.List),
          get children() {
            return m(Vn);
          }
        });
      }
    }), q, Ve), h(w, c(v, {
      get when() {
        return e().options.toolbar.orderedList;
      },
      get children() {
        return c($, {
          onclick: () => r(g.OrderedList),
          get children() {
            return m(On);
          }
        });
      }
    }), pe, Ne), h(w, c(v, {
      get when() {
        return e().options.toolbar.taskList;
      },
      get children() {
        return c($, {
          onclick: () => r(g.TaskList),
          get children() {
            return m(Nn);
          }
        });
      }
    }), qe, Ie), h(K, c(v, {
      get when() {
        return e().options.toolbar.link;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Link),
          get children() {
            return m(Tn);
          }
        });
      }
    }), me, Pe), h(K, c(v, {
      get when() {
        return e().options.toolbar.image;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Image),
          get children() {
            return m(qn);
          }
        });
      }
    }), ke, Fe), h(K, c(v, {
      get when() {
        return e().options.toolbar.upload;
      },
      get children() {
        return c($, {
          onclick: l,
          get children() {
            return [m(In), (() => {
              const Q = m(Rn);
              return o(Q), Q.addEventListener("change", i), Q.style.setProperty("display", "none"), Q;
            })()];
          }
        });
      }
    }), Xe, Ke), a;
  })();
}, Fn = `.ink{color:var(--ink-internal-color, inherit);display:flex;flex-direction:var(--ink-internal-flex-direction, column);gap:1rem;padding:var(--ink-internal-editor-padding, 0)}.ink .cm-tooltip{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);font-family:inherit;padding:.25rem}.ink .cm-tooltip.cm-tooltip-autocomplete ul{font-family:inherit}.ink .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option{border-radius:var(--ink-internal-border-radius);padding:.25rem}.ink .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option[aria-selected]{background-color:#96969640}.ink .cm-completionLabel{font-family:inherit}.ink-mde,.ink-mde *{box-sizing:border-box}.ink-mde .ink-mde-editor-container{display:flex;flex-direction:column;gap:2em}.ink-mde .ink-mde-attribution{display:flex;font-size:.75em;justify-content:flex-end;opacity:.5}.ink-mde .ink-mde-attribution-link{color:currentColor;font-weight:600;text-decoration:none}.ink-mde .ink-mde-task-toggle-wrapper{align-items:center;display:inline-flex;vertical-align:middle;margin-top:-2px}.ink-mde .ink-mde-task-toggle{cursor:pointer;height:1.25em;margin:0;width:1.25em}.ink-mde .cm-editor{display:flex;flex-direction:column;position:relative}.ink-mde .cm-scroller{align-items:flex-start;display:flex;font-family:var(--ink-internal-font-family);font-size:var(--ink-internal-editor-font-size);line-height:var(--ink-internal-editor-line-height);overflow-x:auto;position:relative}.ink-mde .cm-content{display:block;flex-grow:2;flex-shrink:0;margin:0;outline:none;padding:0;white-space:pre;word-wrap:normal}.ink-mde .cm-lineWrapping{flex-shrink:1;overflow-wrap:anywhere;white-space:break-spaces;word-break:break-word}.ink-mde .cm-line{font-family:var(--ink-internal-font-family);padding:0}.ink-mde .cm-line.cm-blockquote{background-color:var(--ink-internal-block-background-color);border-left:.25rem solid currentColor;padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-open{border-top-left-radius:var(--ink-internal-border-radius);border-top-right-radius:var(--ink-internal-border-radius);padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-close{border-bottom-left-radius:var(--ink-internal-border-radius);border-bottom-right-radius:var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-open{border-radius:var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0 0;padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-close{border-radius:0 0 var(--ink-internal-border-radius) var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line .cm-code{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:var(--ink-internal-inline-padding) 0}.ink-mde .cm-line .cm-code.cm-code-open{border-radius:var(--ink-internal-border-radius) 0 0 var(--ink-internal-border-radius);padding-left:var(--ink-internal-inline-padding)}.ink-mde .cm-line .cm-code.cm-code-close{border-radius:0 var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0;padding-right:var(--ink-internal-inline-padding)}.ink-mde .cm-image-backdrop{background-color:var(--ink-internal-block-background-color)}
`, Un = /* @__PURE__ */ k("<style> </style>", 2), Xn = () => {
  const [e] = P(), [t, n] = z(te(e()));
  return et(() => {
    n(te(e()));
  }), ve(() => {
    const o = window.matchMedia("(prefers-color-scheme: dark)"), r = (i) => {
      const {
        editor: l,
        root: a
      } = e();
      a.isConnected ? de(e()).then((s) => {
        l.dispatch({
          effects: s
        }), n(te(e()));
      }) : o.removeEventListener("change", r);
    };
    o.addEventListener("change", r);
  }), (() => {
    const o = m(Un), r = o.firstChild;
    return ne(() => r.data = `.ink {
  ${t().join(`
  `)}
}
${Fn}`), o;
  })();
}, Kn = /* @__PURE__ */ k('<div class="ink-mde-attribution"><span>powered by <a class="ink-mde-attribution-link" href="https://github.com/voracious/ink-mde" rel="noopener noreferrer" target="_blank">ink-mde</a></span></div>', 6), Qn = /* @__PURE__ */ k('<div class="ink ink-mde"><!#><!/><!#><!/><!#><!/><div class="ink-mde-editor-container"><!#><!/><!#><!/></div></div>', 14), Yn = () => {
  const [e, t] = P(), n = (o) => {
    t(R(e(), {
      root: o
    }));
  };
  return (() => {
    const o = m(Qn), r = o.firstChild, [i, l] = x(r.nextSibling), a = i.nextSibling, [s, u] = x(a.nextSibling), b = s.nextSibling, [y, C] = x(b.nextSibling), S = y.nextSibling, M = S.firstChild, [D, B] = x(M.nextSibling), E = D.nextSibling, [f, p] = x(E.nextSibling);
    return n(o), Qe(o, vt, !1, !0), h(o, c(Xn, {}), i, l), h(o, c(v, {
      get when() {
        return e().options.files.clipboard || e().options.files.dragAndDrop;
      },
      get children() {
        return c(Cn, {});
      }
    }), s, u), h(o, c(v, {
      get when() {
        return e().options.interface.toolbar;
      },
      get children() {
        return c(Wn, {});
      }
    }), y, C), h(S, c(Sn, {}), D, B), h(S, c(v, {
      get when() {
        return e().options.interface.attribution;
      },
      get children() {
        return m(Kn);
      }
    }), f, p), se(), o;
  })();
}, Ee = tt([() => ie(), (e) => typeof e == "function" ? e(ie()) : e]), Zn = (e) => c(Ee.Provider, {
  get value() {
    return e.store;
  },
  get children() {
    return e.children;
  }
}), P = () => nt(Ee), je = (e) => c(Zn, {
  get store() {
    return e.store;
  },
  get children() {
    return c(Yn, {
      get store() {
        return e.store;
      }
    });
  }
}), uo = (e) => e, Gn = (e, t = {}) => {
  const n = ue(t);
  return eo(), Ye(() => c(je, {
    store: n
  }), e), Be(n);
}, fo = (e, t = {}) => e.querySelector(bt) ? Gn(e, t) : Jn(e, t), Jn = (e, t = {}) => {
  const n = ue(t);
  return Ze(() => c(je, {
    store: n
  }), e), Be(n);
}, go = (e = {}) => (ue(e), ""), eo = () => {
  let e, t;
  e = window._$HY || (window._$HY = {
    events: [],
    completed: /* @__PURE__ */ new WeakSet(),
    r: {}
  }), t = (n) => n && n.hasAttribute && (n.hasAttribute("data-hk") ? n : t(n.host && n.host instanceof Node ? n.host : n.parentNode)), ["click", "input"].forEach((n) => document.addEventListener(n, (o) => {
    let r = o.composedPath && o.composedPath()[0] || o.target, i = t(r);
    i && !e.completed.has(i) && e.events.push([i, o]);
  })), e.init = (n, o) => {
    e.r[n] = [new Promise((r, i) => o = r), o];
  }, e.set = (n, o, r) => {
    (r = e.r[n]) && r[1](o), e.r[n] = [o];
  }, e.unset = (n) => {
    delete e.r[n];
  }, e.load = (n, o) => {
    if (o = e.r[n])
      return o[0];
  };
};
export {
  V as Appearance,
  wt as Extensions,
  g as Markup,
  oe as PluginType,
  re as Selection,
  fo as default,
  uo as defineOptions,
  Gn as hydrate,
  fo as ink,
  Jn as render,
  go as renderToString,
  eo as solidPrepareForHydration
};
//# sourceMappingURL=client.js.map
